CompositeConfig (Grails 3.2.3)
Date: 2016-11-10

Package: org.grails.config

## [Java] Class CompositeConfig

- org.grails.config.CompositeConfig

- All Implemented Interfaces and Traits:
    Config

      @groovy.transform.CompileStatic
      public class CompositeConfig
      extends java.lang.Object

  A Config composed of other Configs

  Authors:
    Graeme Rocher
  Since:
    3.0

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `protected java.util.Deque<Config>` | `configs` |

  - ### Methods Summary

    Methods
    Type | Name and description
    --- | ---
    `void` | `addFirst(Config config)` Adds a config at the highest level of precedence
    `void` | `addLast(Config config)` Adds a config at the lowest level of precedence
    `void` | `clear()`
    `boolean` | `containsKey(java.lang.Object key)`
    `boolean` | `containsProperty(java.lang.String key)`
    `boolean` | `containsValue(java.lang.Object value)`
    `java.util.Set<Map.Entry<java.lang.String, java.lang.Object>>` | `entrySet()`
    `java.util.Map<java.lang.String, java.lang.Object>` | `flatten()`
    `java.lang.Object` | `get(java.lang.Object key)`
    `java.lang.Object` | `getAt(java.lang.Object key)`
    `T` | `getProperty(java.lang.String key, java.lang.Class<T> targetType, T defaultValue, java.util.List<T> allowedValues)`
    `java.lang.String` | `getProperty(java.lang.String key, java.lang.String defaultValue)`
    `T` | `getProperty(java.lang.String key, java.lang.Class<T> targetType)`
    `T` | `getProperty(java.lang.String key, java.lang.Class<T> targetType, T defaultValue)`
    `java.lang.String` | `getProperty(java.lang.String key)`
    `java.lang.Class<T>` | `getPropertyAsClass(java.lang.String key, java.lang.Class<T> targetType)`
    `java.lang.String` | `getRequiredProperty(java.lang.String key)`
    `T` | `getRequiredProperty(java.lang.String key, java.lang.Class<T> targetType)`
    `boolean` | `isEmpty()`
    `java.util.Iterator<Map.Entry<java.lang.String, java.lang.Object>>` | `iterator()`
    `java.util.Set<java.lang.String>` | `keySet()`
    `Config` | `merge(java.util.Map<java.lang.String, java.lang.Object> toMerge)`
    `java.lang.Object` | `navigate(java.lang.String... path)`
    `java.lang.Object` | `put(java.lang.String key, java.lang.Object value)`
    `void` | `putAll(java.util.Map<? extends java.lang.String, ?> m)`
    `java.lang.Object` | `remove(java.lang.Object key)`
    `java.lang.String` | `resolvePlaceholders(java.lang.String text)`
    `java.lang.String` | `resolveRequiredPlaceholders(java.lang.String text)`
    `void` | `setAt(java.lang.Object key, java.lang.Object value)`
    `int` | `size()`
    `java.util.Properties` | `toProperties()`
    `java.util.Collection<java.lang.Object>` | `values()`

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class java.lang.Object` | `java.lang.Object#wait(long, int), java.lang.Object#wait(long), java.lang.Object#wait(), java.lang.Object#equals(java.lang.Object), java.lang.Object#toString(), java.lang.Object#hashCode(), java.lang.Object#getClass(), java.lang.Object#notify(), java.lang.Object#notifyAll()`

- - ### Field Detail

    - #### protected java.util.Deque<Config> configs

  - ### Method Detail

    - #### public void addFirst(Config config)

      Adds a config at the highest level of precedence

      Parameters:
        config

    - #### public void addLast(Config config)

      Adds a config at the lowest level of precedence

      Parameters:
        config

    - #### @java.lang.Override public void clear()

    - #### @java.lang.Override public boolean containsKey(java.lang.Object key)

    - #### @java.lang.Override public boolean containsProperty(java.lang.String key)

    - #### @java.lang.Override public boolean containsValue(java.lang.Object value)

    - #### @java.lang.Override public java.util.Set<Map.Entry<java.lang.String, java.lang.Object>> entrySet()

    - #### @java.lang.Override @java.lang.Deprecated public java.util.Map<java.lang.String, java.lang.Object> flatten()

    - #### @java.lang.Override public java.lang.Object get(java.lang.Object key)

    - #### @java.lang.Override public java.lang.Object getAt(java.lang.Object key)

    - #### @java.lang.Override public T getProperty(java.lang.String key, java.lang.Class<T> targetType, T defaultValue, java.util.List<T> allowedValues)

    - #### @java.lang.Override public java.lang.String getProperty(java.lang.String key, java.lang.String defaultValue)

    - #### @java.lang.Override public T getProperty(java.lang.String key, java.lang.Class<T> targetType)

    - #### @java.lang.Override public T getProperty(java.lang.String key, java.lang.Class<T> targetType, T defaultValue)

    - #### @java.lang.Override public java.lang.String getProperty(java.lang.String key)

    - #### @java.lang.Override public java.lang.Class<T> getPropertyAsClass(java.lang.String key, java.lang.Class<T> targetType)

    - #### @java.lang.Override public java.lang.String getRequiredProperty(java.lang.String key)

    - #### @java.lang.Override public T getRequiredProperty(java.lang.String key, java.lang.Class<T> targetType)

    - #### @java.lang.Override public boolean isEmpty()

    - #### @java.lang.Override public java.util.Iterator<Map.Entry<java.lang.String, java.lang.Object>> iterator()

    - #### @java.lang.Override public java.util.Set<java.lang.String> keySet()

    - #### @java.lang.Override public Config merge(java.util.Map<java.lang.String, java.lang.Object> toMerge)

    - #### @java.lang.Override public java.lang.Object navigate(java.lang.String... path)

    - #### @java.lang.Override public java.lang.Object put(java.lang.String key, java.lang.Object value)

    - #### @java.lang.Override public void putAll(java.util.Map<? extends java.lang.String, ?> m)

    - #### @java.lang.Override public java.lang.Object remove(java.lang.Object key)

    - #### @java.lang.Override public java.lang.String resolvePlaceholders(java.lang.String text)

    - #### @java.lang.Override public java.lang.String resolveRequiredPlaceholders(java.lang.String text)

    - #### @java.lang.Override public void setAt(java.lang.Object key, java.lang.Object value)

    - #### @java.lang.Override public int size()

    - #### @java.lang.Override public java.util.Properties toProperties()

    - #### @java.lang.Override public java.util.Collection<java.lang.Object> values()